<?php

declare(strict_types=1);

namespace Seka\Portal\Modul\Statistiky\Repositories\Eloquent\Transformers\Summary\ECharts\Pracovisko\PocetKontrolAObratuPodlaSubjektuFakturacie;

use InvalidArgumentException;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaObratuASubjektuFakturacie;
use Seka\Portal\Modul\Statistiky\Repositories\Eloquent\Transformers\Summary\ECharts\EChartSourceItemContract;

/**
 * Class PocetKontrolAObratuPodlaSubjektuFakturacieEChartSourceItem
 *
 * @package Seka\Portal\Modul\Statistiky\Repositories\Eloquent\Transformers\Summary\ECharts\Pracovisko\PocetKontrolAObratuPodlaSubjektuFakturacie
 */
final class PocetKontrolAObratuPodlaSubjektuFakturacieEChartSourceItem implements EChartSourceItemContract
{
    /**
     * @var int
     */
    protected int $pocet = 0;
    /**
     * @var float
     */
    protected float $obrat = 0.0;
    /**
     * @var string
     */
    private string $nazovSubjektu;

    /**
     * @param string $nazovSubjektu
     */
    public function __construct(string $nazovSubjektu)
    {
        $this->nazovSubjektu = $nazovSubjektu;
    }

    /**
     * @param \Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaObratuASubjektuFakturacie $pocetKontrolPodlaObratuASubjektuFakturacie
     *
     * @return $this
     */
    public function add(PocetKontrolPodlaObratuASubjektuFakturacie $pocetKontrolPodlaObratuASubjektuFakturacie): self
    {
        if (!$this->nazovSubjektu == $pocetKontrolPodlaObratuASubjektuFakturacie->nazovSubjektu()) {
            throw new InvalidArgumentException(sprintf(
                'Ocakava sa nazov subjektu fakturacie %s, vstupny atribut obsahuje nazov subjektu fakturacie %s',
                $this->nazovSubjektu,
                $pocetKontrolPodlaObratuASubjektuFakturacie->nazovSubjektu()
            ));
        }

        $this->pocet += $pocetKontrolPodlaObratuASubjektuFakturacie->pocet();
        $this->obrat += $pocetKontrolPodlaObratuASubjektuFakturacie->obrat();

        return $this;
    }

    /**
     * @return string
     */
    public function nazovSubjektu(): string
    {
        return $this->nazovSubjektu;
    }

    /**
     * @return int
     */
    public function pocet(): int
    {
        return $this->pocet;
    }

    /**
     * @return float
     */
    public function obrat(): float
    {
        return $this->obrat;
    }

    /**
     * @param string $nazovSubjektu
     * @param int    $pocet
     * @param float  $obrat
     *
     * @return void
     */
    public function incrementData(string $nazovSubjektu, int $pocet = 0, float $obrat = 0.0)
    {
        if (!$this->nazovSubjektu == $nazovSubjektu) {
            throw new InvalidArgumentException(sprintf(
                'Ocakava sa nazov subjektu fakturacie %s, vstupny atribut obsahuje nazov subjektu fakturacie %s',
                $this->nazovSubjektu,
                $nazovSubjektu
            ));
        }

        $this->pocet += $pocet;
        $this->obrat += $obrat;
    }

    /**
     * @param int $options
     *
     * @return string
     */
    public function toJson(int $options = 0): string
    {
        return json_encode($this->toArray(), $options);
    }

    /**
     * @return array
     */
    public function toArray(): array
    {
        return [
            'label' => $this->nazovSubjektu,
            'obrat' => $this->obrat,
            'pocet' => $this->pocet,
        ];
    }

    /**
     * @return array
     */
    public function jsonSerialize(): array
    {
        return $this->toArray();
    }
}
